"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createFactory;

var _createElement = _interopRequireDefault(require("./createElement"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createFactory(type) {
  var factory = _createElement.default.bind(null, type); // Expose the type on the factory and the prototype so that it can be
  // easily accessed on elements. E.g. `<Foo />.type === Foo`.
  // This should not be named `constructor` since this may not be the function
  // that created the element, and it may not even be a constructor.


  factory.type = type;
  return factory;
}