"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _inject = _interopRequireDefault(require("../vdom/inject"));

var _instance = _interopRequireDefault(require("../vdom/instance"));

var _driverServer = _interopRequireDefault(require("driver-server"));

var _serializer = _interopRequireDefault(require("../server/serializer"));

var _unmountComponentAtNode = _interopRequireDefault(require("../unmountComponentAtNode"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Init
(0, _inject.default)({
  driver: _driverServer.default
});
var _default = {
  create: function create(element) {
    var container = _driverServer.default.createBody();

    var rootComponent = _instance.default.mount(element, container);

    var renderedComponent = rootComponent.getRenderedComponent();

    renderedComponent.toJSON = function () {
      return new _serializer.default(container).toJSON();
    };

    renderedComponent.getInstance = function () {
      return renderedComponent._instance;
    };

    renderedComponent.update = function (element) {
      _instance.default.mount(element, container);
    };

    renderedComponent.unmount = function () {
      (0, _unmountComponentAtNode.default)(container);
    };

    return renderedComponent;
  }
};
exports.default = _default;