"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _host = _interopRequireDefault(require("./host"));

var _native = _interopRequireDefault(require("./native"));

var _instance = _interopRequireDefault(require("./instance"));

var _instantiateComponent = _interopRequireDefault(require("./instantiateComponent"));

var _getElementKeyName = _interopRequireDefault(require("./getElementKeyName"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

/**
 * Fragment Component
 */
var FragmentComponent =
/*#__PURE__*/
function (_NativeComponent) {
  _inherits(FragmentComponent, _NativeComponent);

  function FragmentComponent(element) {
    _classCallCheck(this, FragmentComponent);

    return _possibleConstructorReturn(this, _getPrototypeOf(FragmentComponent).call(this, element));
  }

  _createClass(FragmentComponent, [{
    key: "mountComponent",
    value: function mountComponent(parent, parentInstance, context, childMounter) {
      // Parent native element
      this._parent = parent;
      this._parentInstance = parentInstance;
      this._context = context;
      this._mountID = _host.default.mountID++;
      var instance = {
        _internal: this
      };
      this._instance = instance;
      var fragment = this.getNativeNode();
      var children = this._currentElement; // Process children

      this.mountChildren(children, context);

      if (childMounter) {
        childMounter(fragment, parent);
      } else {
        for (var i = 0; i < fragment.length; i++) {
          var child = fragment[i];

          _host.default.driver.appendChild(child, parent);
        }
      }

      return instance;
    }
  }, {
    key: "mountChildren",
    value: function mountChildren(children, context) {
      var _this = this;

      var renderedChildren = this._renderedChildren = {};
      var fragment = this.getNativeNode();
      var renderedChildrenImage = children.map(function (element, index) {
        var renderedChild = (0, _instantiateComponent.default)(element);
        var name = (0, _getElementKeyName.default)(renderedChildren, element, index);
        renderedChildren[name] = renderedChild;
        renderedChild._mountIndex = index; // Mount

        var mountImage = renderedChild.mountComponent(_this._parent, _this._instance, context, function (nativeNode) {
          if (Array.isArray(nativeNode)) {
            for (var i = 0; i < nativeNode.length; i++) {
              fragment.push(nativeNode[i]);
            }
          } else {
            fragment.push(nativeNode);
          }
        });
        return mountImage;
      });
      return renderedChildrenImage;
    }
  }, {
    key: "unmountComponent",
    value: function unmountComponent(notRemoveChild) {
      if (this._nativeNode) {
        _instance.default.remove(this._nativeNode);

        if (!notRemoveChild) {
          for (var i = 0; i < this._nativeNode.length; i++) {
            _host.default.driver.removeChild(this._nativeNode[i]);
          }
        }
      } // Do not need remove child when their parent is removed


      this.unmountChildren(true);
      this._currentElement = null;
      this._nativeNode = null;
      this._parent = null;
      this._parentInstance = null;
      this._context = null;
      this._instance = null;
    }
  }, {
    key: "updateComponent",
    value: function updateComponent(prevElement, nextElement, prevContext, nextContext) {
      // Replace current element
      this._currentElement = nextElement;
      this.updateChildren(this._currentElement, nextContext);
    }
  }, {
    key: "getNativeNode",
    value: function getNativeNode() {
      if (this._nativeNode == null) {
        this._nativeNode = [];
      }

      return this._nativeNode;
    }
  }, {
    key: "getPublicInstance",
    value: function getPublicInstance() {
      return this.getNativeNode();
    }
  }, {
    key: "getName",
    value: function getName() {
      return 'fragment';
    }
  }]);

  return FragmentComponent;
}(_native.default);

var _default = FragmentComponent;
exports.default = _default;