"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = inject;

var _host = _interopRequireDefault(require("./host"));

var _empty = _interopRequireDefault(require("./empty"));

var _native = _interopRequireDefault(require("./native"));

var _text = _interopRequireDefault(require("./text"));

var _composite = _interopRequireDefault(require("./composite"));

var _fragment = _interopRequireDefault(require("./fragment"));

var _hook = _interopRequireDefault(require("../debug/hook"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function inject(_ref) {
  var driver = _ref.driver,
      hook = _ref.hook,
      measurer = _ref.measurer;
  // Inject component class
  _host.default.EmptyComponent = _empty.default;
  _host.default.NativeComponent = _native.default;
  _host.default.TextComponent = _text.default;
  _host.default.FragmentComponent = _fragment.default;
  _host.default.CompositeComponent = _composite.default; // Inject devtool hook

  _host.default.hook = hook || _hook.default; // Inject performance measurer

  _host.default.measurer = measurer; // Inject render driver

  _host.default.driver = driver || _host.default.driver;

  if (!_host.default.driver) {
    throw Error('Driver not found.');
  }
}