"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _host = _interopRequireDefault(require("./host"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function instantiateComponent(element) {
  var instance;

  if (element === undefined || element === null || element === false || element === true) {
    instance = new _host.default.EmptyComponent();
  } else if (Array.isArray(element)) {
    instance = new _host.default.FragmentComponent(element);
  } else if (_typeof(element) === 'object' && element.type) {
    // Special case string values
    if (typeof element.type === 'string') {
      instance = new _host.default.NativeComponent(element);
    } else {
      instance = new _host.default.CompositeComponent(element);
    }
  } else if (typeof element === 'string' || typeof element === 'number') {
    instance = new _host.default.TextComponent(element);
  } else {
    throw new Error("Invalid element type: ".concat(element, ". (current: ").concat(_typeof(element) === 'object' && Object.keys(element) || _typeof(element), ")"));
  }

  instance._mountIndex = 0;
  return instance;
}

var _default = instantiateComponent;
exports.default = _default;