"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.scheduleIdleCallback = exports.scheduleImmediateCallback = void 0;

var setImmediatePolyfill = function setImmediatePolyfill(job) {
  return setTimeout(job, 0);
}; // 0s


var scheduleImmediateCallback = function scheduleImmediateCallback(callback) {
  var setImmediate = typeof setImmediate === 'undefined' ? setImmediatePolyfill : setImmediate;
  setImmediate(callback);
};

exports.scheduleImmediateCallback = scheduleImmediateCallback;

var requestIdleCallbackPolyfill = function requestIdleCallbackPolyfill(job) {
  return setTimeout(job, 99);
}; // 99ms


var scheduleIdleCallback = function scheduleIdleCallback(callback) {
  var requestIdleCallback = typeof requestIdleCallback === 'undefined' ? requestIdleCallbackPolyfill : requestIdleCallback;
  requestIdleCallback(callback);
};

exports.scheduleIdleCallback = scheduleIdleCallback;