"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _host = _interopRequireDefault(require("./host"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * Text Component
 */
var TextComponent =
/*#__PURE__*/
function () {
  function TextComponent(element) {
    _classCallCheck(this, TextComponent);

    this._currentElement = element;
    this._stringText = String(element);
  }

  _createClass(TextComponent, [{
    key: "mountComponent",
    value: function mountComponent(parent, parentInstance, context, childMounter) {
      this._parent = parent;
      this._parentInstance = parentInstance;
      this._context = context;
      this._mountID = _host.default.mountID++; // Weex dom operation

      var nativeNode = this.getNativeNode();

      if (childMounter) {
        childMounter(nativeNode, parent);
      } else {
        _host.default.driver.appendChild(nativeNode, parent);
      }

      var instance = {
        _internal: this
      };

      _host.default.hook.Reconciler.mountComponent(this);

      return instance;
    }
  }, {
    key: "unmountComponent",
    value: function unmountComponent(notRemoveChild) {
      if (this._nativeNode && !notRemoveChild) {
        _host.default.driver.removeChild(this._nativeNode, this._parent);
      }

      _host.default.hook.Reconciler.unmountComponent(this);

      this._currentElement = null;
      this._nativeNode = null;
      this._parent = null;
      this._parentInstance = null;
      this._context = null;
      this._stringText = null;
    }
  }, {
    key: "updateComponent",
    value: function updateComponent(prevElement, nextElement, context) {
      // If some text do noting
      if (prevElement !== nextElement) {
        // Replace current element
        this._currentElement = nextElement; // Devtool read the latest stringText value

        this._stringText = String(nextElement);

        _host.default.driver.updateText(this.getNativeNode(), this._stringText);

        _host.default.hook.Reconciler.receiveComponent(this);
      }
    }
  }, {
    key: "getNativeNode",
    value: function getNativeNode() {
      if (this._nativeNode == null) {
        this._nativeNode = _host.default.driver.createText(this._stringText);
      }

      return this._nativeNode;
    }
  }]);

  return TextComponent;
}();

var _default = TextComponent;
exports.default = _default;